#!/bin/bash

# Akhmad Fathonih
# akhmadf@gmail.com
# http://blog.neofreko.com
# Buat mamah Sofie :* GIGIT!!!!

# Fixed and improved by:
# Allis Tauri
# allista@gmail.com

CUSTOM='customMenuClicked:'
SUBMENU='Copy Track(s)'
COPY_TO='Flat Copy-to ...'
SMART_COPY_TO='Build dir-tree, using id3 tags ...'
SEP='-'


#setting a trap
trap \
'{
dcop amarok script removeCustomMenuItem "$SUBMENU" "$COPY_TO";
dcop amarok script removeCustomMenuItem "$SUBMENU" "$SMART_COPY_TO";
exit 0;
}' SIGTERM

#add menu
dcop amarok script removeCustomMenuItem "$SUBMENU" "$COPY_TO"
dcop amarok script removeCustomMenuItem "$SUBMENU" "$SMART_COPY_TO"
dcop amarok script addCustomMenuItem "$SUBMENU" "$COPY_TO"
dcop amarok script addCustomMenuItem "$SUBMENU" "$SMART_COPY_TO"

while true; do
   read CMD

   #echo "$CMD"$'\n' >> ~/log.txt

   # check wether our menu is picked
   LEFTO=$(echo "$CMD" | sed "s/$CUSTOM $SUBMENU $COPY_TO //")
   ACT=$(echo $LEFTO | grep ^file | wc -l)
   if [ $ACT = "1" ]; then
      #echo "$LEFTO"$'\n' >> ~/log.txt
      DEST=$(kdialog --getexistingdirectory ~)
      if [ -d "$DEST" ]; then
         kfmclient copy $LEFTO "$DEST"
      fi;
   fi;

   # check wether our menu is picked
   LEFTO=$(echo "$CMD" | sed "s/$CUSTOM $SUBMENU $SMART_COPY_TO //")
   ACT=$(echo $LEFTO | grep ^file | wc -l)
   if [ $ACT = "1" ]; then
      #echo "$LEFTO"$'\n' >> ~/log.txt
      DEST=$(kdialog --getexistingdirectory ~)
      if [ -d "$DEST" ]; then
         for ITEM in $LEFTO; do
            FNAME=$(kfmexec ls $ITEM)
            #echo "FNAME0: $FNAME"$'\n' >> ~/log.txt
            FNAME=$(dcop amarok collection relativePath "$FNAME" | sed "s@'@''@g")
            #echo "FNAME2: $FNAME"$'\n' >> ~/log.txt
            INFO=$(dcop amarok collection query "SELECT artist.name, album.name, tags.title FROM artist LEFT JOIN tags ON (tags.artist=artist.id) LEFT JOIN album ON (tags.album=album.id) WHERE (tags.url LIKE '$FNAME') LIMIT 0,1" | sed "y@ /@_-@" | sed "s@^\$@:@")

            #echo "INFO: $INFO"$'\n' >> ~/log.txt

            ARTIST=$(echo $INFO | sed "y@ @\n@" | head -n 1)
            [[ "$ARTIST" == ":" ]] && ARTIST=""
            ALBUM=$(echo $INFO | sed "y@ @\n@" | head -n 2 | tail -n 1)
            [[ "$ALBUM" == ":" ]] && ALBUM=""
            NAME=$(echo $INFO | sed "y@ @\n@" | head -n 3 | tail -n 1)
            if [[ "$NAME" == ":" ]];
            then NAME=""
            else
              BASENAME=`basename $ITEM`
              EXT=$(echo $BASENAME | sed "s@^.*\.@@")
              [[ "$NAME" == "$BASENAME" ]] || NAME=$NAME.$EXT
            fi

            #echo "NAME: $NAME"$'\n' >> ~/log.txt
            #echo "ARTIST: $ARTIST ALBUM: $ALBUM"$'\n' >> ~/log.txt

            mkdir -p "$DEST/$ARTIST/$ALBUM"
            if [ -d "$DEST/$ARTIST/$ALBUM" ]; then
               #echo "Copying $ITEM to $DEST/$ALBUM"$'\n' >> ~/log.txt
               dcop amarok playlist shortStatusMessage "Copying $(basename $ITEM) to $DEST/$ALBUM"
               kfmclient copy $ITEM "$DEST/$ARTIST/$ALBUM/$NAME"
            fi;
         done;
         dcop amarok playlist popupMessage 'Smart copy is done processing files'
      fi;
   fi;
done
